package nowhere2gopp.network;

import java.rmi.RemoteException;
import nowhere2gopp.board.HexagonalBoard;

import nowhere2gopp.preset.Move;
import nowhere2gopp.preset.Player;
import nowhere2gopp.preset.PlayerColor;
import nowhere2gopp.preset.Status;
import nowhere2gopp.preset.Viewable;
import nowhere2gopp.preset.Viewer;

/**
 * This is a class implementing the concerning interface to be an RMI-client-module. It is able to get move-
 * objects from any type of player and transmit it to the server. The type is defined by a constructor.
 *
 * @author Maurice Mueller
 * @since 2019-07-06
 * @version 1.0
 */
public class RMIClientAcceptorModule implements Player, Viewable{
	/**
	 * This is the object-specific player-object.
	 */
	private Player player;
	
	private HexagonalBoard board;

	/**
	 * This constructor is to declare the used player. His/Her/Its type is set automaticly.
	 *
	 * @param p A player of any type
	 */
	public RMIClientAcceptorModule(Player p) {
		this.player = p;
	}

	/**
	 * This method is used by a server to get moves by the remote players
	 *
	 * @throws RemoteException in case of remote-error
	 * @throws Exception else, in case of bad implemented preset classes
	 * @return a Move generated by a player
	 */
	@Override
	public Move request() throws RemoteException, Exception {
		Move mv = player.request();
		board.make(mv);
		return mv;
	}

	/**
	 * This method is to initialize a player with his player color and the size of a game board.
	 *
	 * @param size The size of a game board to simulate the next moves
	 * @param color The player color for a beginning player (red) or the second player (blue)
	 * @throws RemoteException in case of remote-error
	 * @throws Exception else, in case of bad implemented preset classes
	 */
	@Override
	public void init(int size, PlayerColor color) throws RemoteException, Exception {
		board = new HexagonalBoard(size);
		this.player.init(size, color);
	}

	/**
	 * This method is to offer the current game situation to the other player
	 *
	 * @param opponentMove The move made by other player
	 * @param status The current game status
	 * @throws RemoteException in case of remote-error
	 * @throws Exception else, in case of bad implemented preset classes
	 */
	@Override
	public void update(Move opponentMove, Status status) throws RemoteException, Exception {
		this.player.update(opponentMove, status);
		board.make(opponentMove);
	}

	/**
	 * This method is to let the player know about the current game situation and the correctness of his move
	 *
	 * @param status The current game status
	 * @throws RemoteException in case of remote-error
	 * @throws Exception else, in case of bad implemented preset classes
	 */
	@Override
	public void confirm(Status status) throws RemoteException, Exception {
		this.player.confirm(status);
	}

	@Override
	public Viewer viewer() {
		if(board == null){
			return null;
		}
		return board.viewer();
	}
	
}
